#!/usr/bin/perl

use strict;
use warnings;
use Text::CSV;

my $version = "1.0";

my $basepath = 'C:\mediapath';
my $filename_p1 = 'Track #';
my $filename_p2 = 'Catalog #';

my $file = shift or
    die "Usage: $0 csvfile\nStopped";

my $csv = Text::CSV->new ( { binary => 1 } );

open (CSV, "<", $file) or die $!;

sub print_mpl {
    local $\ = "\r\n";

    print @_;
}

print_mpl '<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>';
print_mpl '<MPL Version="2.0" Title="Created from ', $0, '">';

my @fieldnames;
while (<CSV>) {

    if ($csv->parse($_)) {
	if ($. == 1) {
	    @fieldnames = $csv->fields();
	}
	else {
	    my @cells = $csv->fields();
	    print_item(\@cells, \@fieldnames);
	}
    } else {
	my $error = $csv->error_input;
	print "CVS row parse error: $error";
    }
}
close CSV;

print_mpl '</MPL>';

sub print_item {
    my ($cellsref, $namesref) = @_;

    my ($fp1, $fp2);
    print_mpl '<Item>';
    for (my $i = 0; $i < @$namesref; $i++) {
	unless ($cellsref->[$i] eq '' or $cellsref->[$i] eq '-') {
	    $cellsref->[$i] =~ s/\&/&amp;/g;
	    $cellsref->[$i] =~ s/</&lt;/g;
	    $cellsref->[$i] =~ s/>/&gt;/g;
	    print_mpl '<Field Name="', $namesref->[$i], '">', $cellsref->[$i], '</Field>';
	    $fp1 = $cellsref->[$i] if $namesref->[$i] eq $filename_p1;
	    $fp2 = $cellsref->[$i] if $namesref->[$i] eq $filename_p2;
	}
    }
    print_mpl '<Field Name="Filename">', join('\\', $basepath, "$fp1-$fp2.DSF"), '</Field>';
    print_mpl '<Field Name="Media Type">Audio</Field>';
    print_mpl '</Item>';
}
